  rem Projectile Aiming Demo
  
  
  set doublewide on
  displaymode 160A


  rem Graphics Imports
  rem *********************************
  incgraphic bullet1.png  
  incgraphic herodown1.png  
  incgraphic face1.png 
  
  characterset bullet1

  rem Modify this to make it shoot faster/slower (1/frame)
  const RATEOFFIRE = 12
  
  rem (This is for readability)
  const TRUE = 1
  const FALSE = 0
  
  
  rem Variable Declarations
  rem *********************
  dim HeroX = a
  dim HeroY = b
  dim FaceX = c
  dim FaceY = d
  dim Timer = e
  
  rem Arrays for Bullets
  rem ******************
  dim BulletX      = $2200
  dim BulletXf     = $2210
  dim BulletY      = $2220
  dim BulletYf     = $2230
  
  dim BulletSX     = $2240
  dim BulletSXf    = $2250
  dim BulletSY     = $2260
  dim BulletSYf    = $2270
  
  dim BulletActive    = $2280
  dim BulletDirection = $2290
  
  dim TotalXSu = var1
  dim TotalXSf = var2
  dim TotalSpeedX = TotalXSu.TotalXSf
  
  dim TotalYSu = var3
  dim TotalYSf = var4
  dim TotalSpeedY = TotalYSu.TotalYSf

  dim TempXSu = var5
  dim TempXSf = var6
  dim TempSpeedX = TempXSu.TempXSf
  
  dim TempYSu = var7
  dim TempYSf = var8
  dim TempSpeedY = TempYSu.TempYSf
  
  dim MobSpeedY = var98.var99
  dim MobSpeedX = var96.var97
  dim MobPosY = var90.var91
  dim MobPosX = var92.var93
  
  
  rem ** Initialize Variables
  HeroX = 0
  HeroY = 0
  
  FaceX = 80
  FaceY = 96
  
  rem Palette Setting
  rem *****************
  
  rem Hero! (The target!)
  P0C1=herodown1_color1
  P0C2=herodown1_color2
  P0C3=herodown1_color3

  rem Face! (The shooter!)
  P1C1=$82
  P1C2=$48
  P1C3=$fb
  
  rem Bullets! (The.. yeah.)
  P2C1=$0F
  P2C2=$45
  P2C3=$fa

  Timer = RATEOFFIRE
  
  
main_loop

  rem Controls How Fast we shoot bullets
  rem **********************************
  Timer = Timer - 1
  if Timer = 0 then gosub ShootBullet : Timer = RATEOFFIRE

  rem Move Hero (With Player 1)
  rem *************************
  if joy0up then HeroY = HeroY - 1
  if joy0down then HeroY = HeroY + 1
  if joy0left then HeroX = HeroX - 1
  if joy0right then HeroX = HeroX + 1
  
  rem Move Face (With Player 2)
  rem *************************
  if joy1up then FaceY = FaceY - 1
  if joy1down then FaceY = FaceY + 1
  if joy1left then FaceX = FaceX - 1
  if joy1right then FaceX = FaceX + 1

  
  rem Remove off-screen Bullets 
  rem *************************
  z = 15
DespawnCheck 
  if BulletX[z] > 160 || BulletY[z] > 192  then BulletActive[z] = FALSE
  z = z - 1
  if z < 15 then goto DespawnCheck

  rem Move the bullets!
  rem *****************
  gosub MoveBullet

  clearscreen
  
  plotsprite herodown1 0 HeroX HeroY  
  plotsprite face1     1 FaceX FaceY 

  z = 15
PlotBullet
  x = BulletX[z]
  y = BulletY[z]
  if BulletActive[z] = TRUE then plotsprite bullet1 2 x y
  z = z - 1
  if z < 15 then goto PlotBullet

  drawscreen  
  goto main_loop
  

  
  
ShootBullet
  rem Cycles through Bullet array, looking for the first available (inactive) Bullet.
  rem If all are in use, it terminates without adding a new bullet.
  
  z = 15
CheckMoreBullets
  
  if BulletActive[z] = TRUE then goto skipBullet
    
    rem Register The Bullet For Plotting
    rem ********************************
    BulletActive[z] = TRUE
    
    rem This determines where the bullet will START.
    rem ********************************************
    BulletX[z] = FaceX+2
    BulletY[z] = FaceY+4
        
	TempXSu = 0
	TempYSu = 0

    rem These set the base speeds to throw the bullet at the target.
    rem It will aim at the top-left corner of the sprite the way it's currently set up.
    rem To make it aim elsewhere on the sprite, you will need to adjust HeroX and HeroY.

    if HeroX = BulletX[z] then TempXSf = 0 
    if HeroX > BulletX[z] then TempXSf = HeroX - BulletX[z]
    if HeroX < BulletX[z] then TempXSf = BulletX[z] - HeroX

    if HeroY = BulletY[z] then TempYSf = 0 
    if HeroY > BulletY[z] then TempYSf = HeroY - BulletY[z]
    if HeroY < BulletY[z] then TempYSf = BulletY[z] - HeroY

        rem A little variance! (Remove REMs and recompile to see it!)
        rem This makes them spread out a bit rather than directly target the same spot!
        rem ***************************************************************************
        rem w = (rand/16)
        rem if TempXSf > 8 then TempXSf = TempXSf + w - 8  else TempXSf = TempXSf + w 
        rem w = (rand/16)
        rem if TempYSf > 8 then TempYSf = TempYSf + w - 8  else TempYSf = TempYSf + w 


    rem Protection against mob being directly over player! (Routine will never end!)
    rem **************************************************
    if TempYSf = 0 && TempXSf = 0 then BulletActive[z] = FALSE : return

    rem Setting Directional Flags (bit-setting doesn't like arrays!)
    rem ************************************************************
    if HeroX <= BulletX[z] then BulletDirection[z] = BulletDirection[z] | %00000010  else BulletDirection[z] = BulletDirection[z] & %11111101
    if HeroY <= BulletY[z] then BulletDirection[z] = BulletDirection[z] | %00000001  else BulletDirection[z] = BulletDirection[z] & %11111110


    rem Empty Speed Values (In case of old data lingering inside!)
    rem **********************************************************
    TempXSu = 0
    TempYSu = 0

    TotalXSu = 0
    TotalXSf = 0
    TotalYSu = 0
    TotalYSf = 0

SB_IncreaseSpeeds

    TotalSpeedX = TotalSpeedX + TempSpeedX
    TotalSpeedY = TotalSpeedY + TempSpeedY
  
    rem ** This loop ensures at least one direction will be speed = 1.
    rem    Actual speed produced will vary however. (For PAL50 conversion, might need to do a more complicated check.)
    if TotalXSu = 0 && TotalYSu = 0 then goto SB_IncreaseSpeeds


  rem Copy Total Speed to Bullet Speed
  rem ********************************	
  BulletSX[z]  = TotalXSu
  BulletSXf[z] = TotalXSf
  BulletSY[z]  = TotalYSu
  BulletSYf[z] = TotalYSf

  rem We're done No need to check any more bullets for now.
  return

skipBullet
  z = z - 1
  if z < 15 then goto CheckMoreBullets
  return
  
  
  

  
MoveBullet

  z = 15
UpdateBulletPositions
       
    var90 = BulletY[z]
    var91 = BulletYf[z]
    var92 = BulletX[z]
    var93 = BulletXf[z]
  
    var96 = BulletSX[z]
    var97 = BulletSXf[z]
    var98 = BulletSY[z]
    var99 = BulletSYf[z]
  
    if (BulletDirection[z]&1) = 1 then MobPosY = MobPosY - MobSpeedY else MobPosY = MobPosY + MobSpeedY  
    if (BulletDirection[z]&2) = 2 then MobPosX = MobPosX - MobSpeedX else MobPosX = MobPosX + MobSpeedX
  
    BulletY[z]  = var90
    BulletYf[z] = var91
    BulletX[z]  = var92
    BulletXf[z] = var93

    z = z - 1
  if z < 15 then goto UpdateBulletPositions
  return  

    